/**
 *	@file	DonutConfirmOption.h
 *	@brief	donutIvV: mF_CAOɊւݒvpeBy[W. IɃ[U[֊mFo܂.
 *	@note
 *			IɃ[U[֊mFo܂݂܂B
 *			IɊmFsCDonutConfirmOptionƂ̐ݒs
 *			vpeBy[WCDonutConfirmPropertyPageL܂B
 */

#pragma once

#include "../resource.h"
#include "../MtlWin.h"



/**
	CDonutConfirmOption
	emF_CAOo߂̃NX
 */
class CDonutConfirmOption {
	friend class CDonutConfirmPropertyPage;

private:
	//mF_CAO̐ݒtO̒萔
	enum EDonut_Confirm {
		DONUT_CONFIRM_EXIT			 = 0x00000001L,
		DONUT_CONFIRM_CLOSEALL		 = 0x00000002L,
		DONUT_CONFIRM_CLOSEALLEXCEPT = 0x00000004L,
		DONUT_CONFIRM_STOPSCRIPT	 = 0x00000008L,
	};

	//oϐ
	static DWORD	s_dwFlags;
	//x static BOOL s_bStopScript;
	static DWORD	s_dwStopScript;

public:
	//o֐
	static void 	GetProfile();
	static void 	WriteProfile();

	static bool 	OnDonutExit(HWND hWnd = NULL);
	static bool 	OnCloseAll(HWND hWnd = NULL);
	static bool 	OnCloseAllExcept(HWND hWnd = NULL);
	static BOOL 	WhetherConfirmScript();

private:
	static bool 	_SearchDownloadingDialog();

	//Ŏgp\
	struct _Function_Searcher {
		bool	m_bFound;

		_Function_Searcher() : m_bFound(false) { }

		bool operator ()(HWND hWnd)
		{
			if ( MtlIsWindowCurrentProcess(hWnd) ) {
				CString strCaption = MtlGetWindowText(hWnd);

				if ( (strCaption.Find( _T('%') ) != -1 && strCaption.Find( _T("܂") ) != -1)
				   || strCaption.Find( _T("t@C̃_E[h") ) != -1 )
				{
					m_bFound = true;
					return false;
				}
			}

			return true; // continue finding
		}
	};

};


/**
	CDonutConfirmPropertyPage
	mF_CAOɊւݒvpeBy[W
 */
class CDonutConfirmPropertyPage
	: public CPropertyPageImpl<CDonutConfirmPropertyPage>
	, public CWinDataExchange<CDonutConfirmPropertyPage>
{
public:
	//_CAO\[XID
	enum { IDD = IDD_PROPPAGE_CONFIRMDLG };

private:
	//oϐ
	int 	m_nExit;
	int		m_nCloseAll;
	int		m_nCloseAllExcept;
	int 	m_nStopScript;

public:
	//DDX}bv
	BEGIN_DDX_MAP(CDonutConfirmPropertyPage)
		DDX_CHECK( IDC_CHECK_CFD_EXIT,			m_nExit 		 )
		DDX_CHECK( IDC_CHECK_CFD_CLOSEALL,		m_nCloseAll 	 )
		DDX_CHECK( IDC_CHECK_CFD_CLOSEEXCEPT,	m_nCloseAllExcept)
		DDX_CHECK( IDC_CHECK_CFD_STOPSCRIPT,	m_nStopScript	 )
	END_DDX_MAP()

	//RXgN^
	CDonutConfirmPropertyPage();

	//vpeBy[W̃I[o[Ch֐
	BOOL	OnSetActive();
	BOOL	OnKillActive();
	BOOL	OnApply();

	//֐
private:
	void	_GetData();
	void	_SetData();
};


